package com.mamezou.sample.business;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Map;
import java.util.TreeMap;

/**
 * ANVACeǗNXB
 * Iœ삷邽߁AsxɏB
 * @author MBeans
 * @version 1.0
 */
public class OnMemoryActionItemManagerImpl implements ActionItemManager {

    private static int NEXT_ID = 0;

    private Map<Integer, ActionItem> actionItems;

    OnMemoryActionItemManagerImpl() {
        actionItems = new TreeMap<Integer, ActionItem>();
        initActionItems();
    }

    private void initActionItems() {
        String[][] data = {
            {"DIxAOPRei̐쐬B", "20060731", "A"},
            {"Spring Portlet MVC̕׋JB", "20060902", "B"},
            {"Spring JDBC̃Tv쐬B", "20060715", "C"},
            {"Spring̃NCbNX^[g쐬B", "20060816", "D"},
        };
        for (String[] d : data) {
            ActionItem actionItem
                    = addActionItem(new ActionItem(d[0], toDate(d[1]), d[2]));
            if (actionItem.getId() % 2 != 0) {
                actionItem.setCompletion(true);
            }
        }
    }

    private Date toDate(String yyyyMMdd) {
        try {
            return new SimpleDateFormat("yyyyMMdd").parse(yyyyMMdd);
        } catch (ParseException e) {
            throw new IllegalArgumentException(e);
        }
    }

    public ActionItem getActionItem(Integer id) {
        return actionItems.get(id);
    }

    public Iterable<ActionItem> getActionItems() {
        return actionItems.values();
    }


    public ActionItem addActionItem(ActionItem actionItem) {
        actionItem.setId(getNextId());
        actionItems.put(actionItem.getId(), actionItem);
        return actionItem;
    }

    private int getNextId() {
        return NEXT_ID++;
    }

    public ActionItem editActionItem(ActionItem actionItem) {
        return actionItems.put(actionItem.getId(), actionItem);
    }

    public ActionItem removeActionItem(Integer id) {
        return actionItems.remove(id);
    }
}
