package com.mamezou.sample.portlet;

import java.io.IOException;

import javax.portlet.ActionRequest;
import javax.portlet.ActionResponse;
import javax.portlet.GenericPortlet;
import javax.portlet.PortletException;
import javax.portlet.RenderRequest;
import javax.portlet.RenderResponse;

import com.mamezou.sample.business.MessageManager;
import com.mamezou.sample.business.OnMemoryMessageManagerImpl;

/**
 * bZ[W|[gbg
 * @author MBeans
 * @version 1.0
 */
public class MessagePortlet extends GenericPortlet {

    private MessageManager messageManager = new OnMemoryMessageManagerImpl();

    public void processAction(ActionRequest request, ActionResponse response)
            throws PortletException, IOException {
        messageManager.setMessage(request.getParameter("message"));
    }

    protected void doView(RenderRequest request, RenderResponse response)
            throws PortletException, IOException {
        request.setAttribute("message", messageManager.getMessage());
        include(request, response, "/WEB-INF/jsp/viewMessage.jsp");
    }

    protected void doEdit(RenderRequest request, RenderResponse response)
            throws PortletException, IOException {
        request.setAttribute("message", messageManager.getMessage());
        include(request, response, "/WEB-INF/jsp/editMessage.jsp");
    }

    private void include(
            RenderRequest request, RenderResponse response,
            String path) throws PortletException, IOException {
        getPortletContext()
                .getRequestDispatcher(path).include(request, response);
    }
}
