package com.mamezou.sample.portletmvc;

import java.util.Date;

import javax.portlet.ActionRequest;
import javax.portlet.ActionResponse;
import javax.portlet.PortletMode;
import javax.portlet.PortletModeException;
import javax.portlet.PortletRequest;

import org.springframework.beans.propertyeditors.CustomDateEditor;
import org.springframework.validation.BindException;
import org.springframework.web.portlet.bind.PortletRequestDataBinder;
import org.springframework.web.portlet.mvc.SimpleFormController;

import com.mamezou.sample.business.ActionItem;
import com.mamezou.sample.business.ActionItemManager;

/**
 * ANVACeύXRg[B
 * @author MBeans
 * @version 1.0
 */
public class EditActionItemController extends SimpleFormController {

    private ActionItemManager actionItemManager;

    public void setActionItemManager(ActionItemManager actionItemManager) {
        this.actionItemManager = actionItemManager;
    }

    protected Object formBackingObject(PortletRequest request) {
        return actionItemManager.getActionItem(
                Integer.valueOf(request.getParameter("id")));
    }

    protected void initBinder(
            PortletRequest request, PortletRequestDataBinder binder) {
        binder.registerCustomEditor(
            Date.class, "deadline",
            new CustomDateEditor(ActionItemManager.DEFAULT_DATE_FORMAT, true));
    }

    protected void onSubmitAction(
            ActionRequest request, ActionResponse response,
            Object command, BindException errors) throws PortletModeException {
        ActionItem actionItem
                = actionItemManager.editActionItem((ActionItem) command);
        response.setPortletMode(PortletMode.VIEW);
        response.setRenderParameter("action", "viewActionItem");
        response.setRenderParameter("id", actionItem.getId().toString());
    }
}
