package com.mamezou.sample.validation;

import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import org.springframework.validation.Validator;

import com.mamezou.sample.business.ActionItem;

/**
 * ANVACeof[^B
 * @author MBeans
 * @version 1.0
 */
public class ActionItemValidator implements Validator {

    public boolean supports(Class clazz) {
        return ActionItem.class.isAssignableFrom(clazz);
    }

    public void validate(Object obj, Errors errors) {
        ValidationUtils.rejectIfEmpty(errors, "actionName", "required");
        ValidationUtils.rejectIfEmpty(errors, "deadline", "required");
        ValidationUtils.rejectIfEmpty(errors, "worker", "required");
    }
}
